const DATA_SOURCE_QUERY_OPERATORS = [
	'=',
	'!=',
	'>=',
	'<=',
	'>',
	'<',
	'LIKE',
	'ILIKE',
	'REGEXP',
] as const;

type DataSourceQueryOperator = typeof DATA_SOURCE_QUERY_OPERATORS[number];

interface DataSourceQueryOperatorExpression {
	lhs: string;
	operator: DataSourceQueryOperator;
	rhs: string | number | boolean | RegExp;
}

interface DataSourceQueryOrGrouping {
	type: 'or';
	expressions: DataSourceQueryOperatorExpression[];
}

interface DataSourceQueryAndGrouping {
	type: 'and';
	expressions: DataSourceQueryOrGrouping[];
}

export type DataSourceQueryExpression = DataSourceQueryOperatorExpression;

export type DataSourceQuery = DataSourceQueryAndGrouping;

export interface QueryMediaType<
	Name extends string = string,
	SerializeOptions extends {} = {},
	DeserializeOptions extends {} = {}
> {
	name: Name;
	serialize: (object: DataSourceQuery, opts?: SerializeOptions) => string;
	deserialize: (s: string, opts?: DeserializeOptions) => DataSourceQuery;
}
